gtkmm 4.10.0

Public Types | Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gtk::FlowBox Class Reference
Widgets | Container Widgets

A container that allows reflowing its children. More...

`#include <gtkmm/flowbox.h>`

Inheritance diagram for Gtk::FlowBox:
[legend]

## Public Types
typedef sigc::slot< void(FlowBox *, FlowBoxChild *)> | SlotSelectedForeach
| For instance: void foreach_child(FlowBox* box, FlowBoxChild* child);. More...
typedef sigc::slot< bool(FlowBoxChild *)> | SlotFilter
| For instance: bool on_filter(FlowBoxChild* child);. More...
typedef sigc::slot< int(FlowBoxChild *, FlowBoxChild *)> | SlotSort
| For instance: int on_sort(FlowBoxChild* child1, FlowBoxChild* child2) More...
template<typename T_item >
using | SlotCreateWidget = sigc::slot< Gtk::Widget *(const Glib::RefPtr< T_item > &)>
| For instance: Gtk::Widget* on_create_widget(const Glib::RefPtr<T_item>& item);. More...
Public Types inherited from Gtk::Widget
using | SlotTick = sigc::slot< bool(const Glib::RefPtr< Gdk::FrameClock > &)>
| Callback type for adding a function to update animations. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gtk::Accessible
enum class | Role { ALERT , ALERT_DIALOG , BANNER , BUTTON , CAPTION , CELL , CHECKBOX , COLUMN_HEADER , COMBO_BOX , COMMAND , COMPOSITE , DIALOG , DOCUMENT , FEED , FORM , GENERIC , GRID , GRID_CELL , GROUP , HEADING , IMG , INPUT , LABEL , LANDMARK , LEGEND , LINK , LIST , LIST_BOX , LIST_ITEM , LOG , MAIN , MARQUEE , MATH , METER , MENU , MENU_BAR , MENU_ITEM , MENU_ITEM_CHECKBOX , MENU_ITEM_RADIO , NAVIGATION , NONE , NOTE , OPTION , PRESENTATION , PROGRESS_BAR , RADIO , RADIO_GROUP , RANGE , REGION , ROW , ROW_GROUP , ROW_HEADER , SCROLLBAR , SEARCH , SEARCH_BOX , SECTION , SECTION_HEAD , SELECT , SEPARATOR , SLIDER , SPIN_BUTTON , STATUS , STRUCTURE , SWITCH , TAB , TABLE , TAB_LIST , TAB_PANEL , TEXT_BOX , TIME , TIMER , TOOLBAR , TOOLTIP , TREE , TREE_GRID , TREE_ITEM , WIDGET , WINDOW , TOGGLE_BUTTON }
| The accessible role for a Gtk::Accessible implementation. More...
enum class | State { BUSY , CHECKED , DISABLED , EXPANDED , HIDDEN , INVALID , PRESSED , SELECTED }
| The possible accessible states of a Gtk::Accessible. More...
enum class | Property { AUTOCOMPLETE , DESCRIPTION , HAS_POPUP , KEY_SHORTCUTS , LABEL , LEVEL , MODAL , MULTI_LINE , MULTI_SELECTABLE , ORIENTATION , PLACEHOLDER , READ_ONLY , REQUIRED , ROLE_DESCRIPTION , SORT , VALUE_MAX , VALUE_MIN , VALUE_NOW , VALUE_TEXT }
| The possible accessible properties of a Gtk::Accessible. More...
enum class | Relation { ACTIVE_DESCENDANT , COL_COUNT , COL_INDEX , COL_INDEX_TEXT , COL_SPAN , CONTROLS , DESCRIBED_BY , DETAILS , ERROR_MESSAGE , FLOW_TO , LABELLED_BY , OWNS , POS_IN_SET , ROW_COUNT , ROW_INDEX , ROW_INDEX_TEXT , ROW_SPAN , SET_SIZE }
| The possible accessible relations of a Gtk::Accessible. More...
enum class | PlatformState { FOCUSABLE , FOCUSED , ACTIVE }
| The various platform states which can be queried using Gtk::Accessible::get_platform_state(). More...

## Public Member Functions
| FlowBox (FlowBox && src) noexcept
FlowBox & | operator= (FlowBox && src) noexcept
| FlowBox (const FlowBox &)=delete
FlowBox & | operator= (const FlowBox &)=delete
| ~FlowBox () noexcept override
GtkFlowBox * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkFlowBox * | gobj () const
| Provides access to the underlying C GObject. More...
| FlowBox ()
| Creates a FlowBox. More...
void | set_homogeneous (bool homogeneous=true)
| Sets whether or not all children of box are given equal space in the box. More...
bool | get_homogeneous () const
| Returns whether the box is homogeneous. More...
void | set_row_spacing (guint spacing)
| Sets the vertical space to add between children. More...
guint | get_row_spacing () const
| Gets the vertical spacing. More...
void | set_column_spacing (guint spacing)
| Sets the horizontal space to add between children. More...
guint | get_column_spacing () const
| Gets the horizontal spacing. More...
void | set_min_children_per_line (guint n_children)
| Sets the minimum number of children to line up in box’s orientation before flowing. More...
guint | get_min_children_per_line () const
| Gets the minimum number of children per line. More...
void | set_max_children_per_line (guint n_children)
| Sets the maximum number of children to request and allocate space for in box’s orientation. More...
guint | get_max_children_per_line () const
| Gets the maximum number of children per line. More...
void | set_activate_on_single_click (bool single=true)
| If single is `true`, children will be activated when you click on them, otherwise you need to double-click. More...
bool | get_activate_on_single_click () const
| Returns whether children activate on single clicks. More...
void | prepend (Widget & child)
| Adds child to the start of self. More...
void | append (Widget & child)
| Adds child to the end of self. More...
void | insert (Widget & widget, int position)
| Inserts the widget into box at position. More...
void | remove (Widget & widget)
| Removes a child from box. More...
FlowBoxChild * | get_child_at_index (int idx)
| Gets the nth child in the box. More...
const FlowBoxChild * | get_child_at_index (int idx) const
| Gets the nth child in the box. More...
FlowBoxChild * | get_child_at_pos (int x, int y)
| Gets the child in the ( x, y) position. More...
const FlowBoxChild * | get_child_at_pos (int x, int y) const
| Gets the child in the ( x, y) position. More...
void | selected_foreach (const SlotSelectedForeach & slot)
| Calls a function for each selected child. More...
std::vector< Gtk::FlowBoxChild * > | get_selected_children ()
| Creates a list of all selected children. More...
std::vector< const Gtk::FlowBoxChild * > | get_selected_children () const
| Creates a list of all selected children. More...
void | select_child (FlowBoxChild & child)
| Selects a single child of box, if the selection mode allows it. More...
void | unselect_child (FlowBoxChild & child)
| Unselects a single child of box, if the selection mode allows it. More...
void | select_all ()
| Select all children of box, if the selection mode allows it. More...
void | unselect_all ()
| Unselect all children of box, if the selection mode allows it. More...
void | set_selection_mode (SelectionMode mode=SelectionMode::NONE)
| Sets how selection works in box. More...
SelectionMode | get_selection_mode () const
| Gets the selection mode of box. More...
void | set_hadjustment (const Glib::RefPtr< Adjustment > & adjustment)
| Hooks up an adjustment to focus handling in box. More...
void | set_vadjustment (const Glib::RefPtr< Adjustment > & adjustment)
| Hooks up an adjustment to focus handling in box. More...
void | set_filter_func (const SlotFilter & slot)
| Sets a filter function. More...
void | unset_filter_func ()
| Removes the filter function, if any. More...
void | invalidate_filter ()
| Updates the filtering for all children. More...
void | set_sort_func (const SlotSort & slot)
| Sets a sort function. More...
void | unset_sort_func ()
| Removes the sort function, if any. More...
void | invalidate_sort ()
| Updates the sorting for all children. More...
void | bind_model (const Glib::RefPtr< Gio::ListModel > & model, const SlotCreateWidget< Glib::Object > & slot_create_widget)
| Binds a Gio::ListModel. More...
template<typename T_item , typename T_slot >
void | bind_list_store (const Glib::RefPtr< Gio::ListStore< T_item >> & store, T_slot && slot_create_widget)
| Binds a Gio::ListStore<>. More...
Glib::PropertyProxy< SelectionMode > | property_selection_mode ()
| The selection mode used by the flow box. More...
Glib::PropertyProxy_ReadOnly< SelectionMode > | property_selection_mode () const
| The selection mode used by the flow box. More...
Glib::PropertyProxy< bool > | property_activate_on_single_click ()
| Determines whether children can be activated with a single click, or require a double-click. More...
Glib::PropertyProxy_ReadOnly< bool > | property_activate_on_single_click () const
| Determines whether children can be activated with a single click, or require a double-click. More...
Glib::PropertyProxy< bool > | property_accept_unpaired_release ()
| Default value: `false` More...
Glib::PropertyProxy_ReadOnly< bool > | property_accept_unpaired_release () const
| Default value: `false` More...
Glib::PropertyProxy< bool > | property_homogeneous ()
| Determines whether all children should be allocated the same size. More...
Glib::PropertyProxy_ReadOnly< bool > | property_homogeneous () const
| Determines whether all children should be allocated the same size. More...
Glib::PropertyProxy< guint > | property_min_children_per_line ()
| The minimum number of children to allocate consecutively in the given orientation. More...
Glib::PropertyProxy_ReadOnly< guint > | property_min_children_per_line () const
| The minimum number of children to allocate consecutively in the given orientation. More...
Glib::PropertyProxy< guint > | property_max_children_per_line ()
| The maximum amount of children to request space for consecutively in the given orientation. More...
Glib::PropertyProxy_ReadOnly< guint > | property_max_children_per_line () const
| The maximum amount of children to request space for consecutively in the given orientation. More...
Glib::PropertyProxy< guint > | property_row_spacing ()
| The amount of vertical space between two children. More...
Glib::PropertyProxy_ReadOnly< guint > | property_row_spacing () const
| The amount of vertical space between two children. More...
Glib::PropertyProxy< guint > | property_column_spacing ()
| The amount of horizontal space between two children. More...
Glib::PropertyProxy_ReadOnly< guint > | property_column_spacing () const
| The amount of horizontal space between two children. More...
Glib::SignalProxy< void(FlowBoxChild *)> | signal_child_activated ()
Glib::SignalProxy< void()> | signal_selected_children_changed ()
Public Member Functions inherited from Gtk::Widget
| Widget (Widget && src) noexcept
Widget & | operator= (Widget && src) noexcept
| Widget (const Widget &)=delete
Widget & | operator= (const Widget &)=delete
| ~Widget () noexcept override
| Destroys the widget. More...
GtkWidget * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkWidget * | gobj () const
| Provides access to the underlying C GObject. More...
Glib::RefPtr< ConstraintTarget > | make_refptr_constrainttarget ()
| Converts this widget to a reference counted Gtk::ConstraintTarget. More...
Glib::RefPtr< const ConstraintTarget > | make_refptr_constrainttarget () const
| Converts this widget to a reference counted Gtk::ConstraintTarget. More...
void | show ()
| Flags a widget to be displayed. More...
void | hide ()
| Reverses the effects of show(). More...
void | queue_draw ()
| Schedules this widget to be redrawn in the paint phase of the current or the next frame. More...
void | queue_resize ()
| Flags a widget to have its size renegotiated. More...
void | queue_allocate ()
| Flags the widget for a rerun of the size_allocate_vfunc() function. More...
void | size_allocate (const Allocation & allocation, int baseline)
| Allocates widget with a transformation that translates the origin to the position in allocation. More...
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout. More...
void | measure (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size. More...
void | get_preferred_size (Requisition & minimum_size, Requisition & natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management. More...
void | set_layout_manager (const Glib::RefPtr< LayoutManager > & layout_manager)
| Sets the layout manager delegate instance that provides an implementation for measuring and allocating the children of widget. More...
void | unset_layout_manager ()
| Undoes the effect of a previous call to set_layout_manager(). More...
Glib::RefPtr< LayoutManager > | get_layout_manager ()
| Retrieves the layout manager used by widget. More...
Glib::RefPtr< const LayoutManager > | get_layout_manager () const
| Retrieves the layout manager used by widget. More...
bool | mnemonic_activate (bool group_cycling)
| Emits the signal_mnemonic_activate() signal. More...
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them. More...
void | set_can_focus (bool can_focus=true)
| Specifies whether the input focus can enter the widget or any of its children. More...
bool | get_can_focus () const
| Determines whether the input focus can enter widget or any of its children. More...
void | set_focusable (bool focusable=true)
| Specifies whether widget can own the input focus. More...
bool | get_focusable () const
| Determines whether widget can own the input focus. More...
bool | has_focus () const
| Determines if the widget has the global input focus. More...
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel. More...
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus. More...
bool | grab_focus ()
| Causes widget to have the keyboard focus for the `Gtk::Window` it's inside. More...
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse. More...
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse. More...
void | set_can_target (bool can_target=true)
| Sets whether widget can be the target of pointer events. More...
bool | get_can_target () const
| Queries whether widget can be the target of pointer events. More...
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel. More...
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
bool | get_receives_default () const
| Determines whether widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
void | set_name (const Glib::ustring & name)
| Sets a widgets name. More...
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget. More...
void | set_state_flags (StateFlags flags, bool clear=true)
| Turns on flag values in the current widget state. More...
void | unset_state_flags (StateFlags flags)
| Turns off flag values for the current widget state. More...
StateFlags | get_state_flags () const
| Returns the widget state as a flag set. More...
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget. More...
bool | get_sensitive () const
| Returns the widget’s sensitivity. More...
bool | is_sensitive () const
| Returns the widget’s effective sensitivity. More...
void | set_visible (bool visible=true)
| Sets the visibility state of widget. More...
bool | get_visible () const
| Determines whether the widget is visible. More...
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible. More...
bool | is_drawable () const
| Determines whether widget can be drawn to. More...
bool | get_realized () const
| Determines whether widget is realized. More...
bool | get_mapped () const
| Whether the widget is mapped. More...
void | set_child_visible (bool visible=true)
| Sets whether widget should be mapped along with its parent. More...
bool | get_child_visible () const
| Gets the value set with set_child_visible(). More...
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget. More...
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget. More...
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to widget. More...
Allocation | get_allocation () const
| Retrieves the widget’s location. More...
int | get_width () const
| Returns the content width of the widget. More...
int | get_height () const
| Returns the content height of the widget. More...
int | get_size (Orientation orientation) const
| Returns the content width or height of the widget. More...
Widget * | get_parent ()
| Returns the parent widget of widget. More...
const Widget * | get_parent () const
| Returns the parent widget of widget. More...
Root * | get_root ()
| Returns the `Gtk::Root` widget of widget. More...
const Root * | get_root () const
| Returns the `Gtk::Root` widget of widget. More...
Native * | get_native ()
| Returns the nearest `Gtk::Native` ancestor of widget. More...
const Native * | get_native () const
| Returns the nearest `Gtk::Native` ancestor of widget. More...
bool | child_focus (DirectionType direction)
| Called by widgets as the user moves around the window using keyboard shortcuts. More...
bool | keynav_failed (DirectionType direction)
| Emits the `::keynav-failed` signal on the widget. More...
void | error_bell ()
| Notifies the user about an input-related error on this widget. More...
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget. More...
void | get_size_request (int & width, int & height) const
| Gets the size request that was explicitly set for the widget using set_size_request(). More...
void | set_opacity (double opacity)
| Request the widget to be rendered partially transparent. More...
double | get_opacity () const
| #Fetches the requested opacity for this widget. More...
void | set_overflow (Overflow overflow)
| Sets how widget treats content that is drawn outside the widget's content area. More...
Overflow | get_overflow () const
| Returns the widgets overflow value. More...
Widget * | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type. More...
const Widget * | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type. More...
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels. More...
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the `Gdk::Display` for the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the `Gdk::Display` for the toplevel window associated with this widget. More...
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget. More...
Glib::RefPtr< Gdk::Clipboard > | get_clipboard ()
| Gets the clipboard object for widget. More...
Glib::RefPtr< const Gdk::Clipboard > | get_clipboard () const
| Gets the clipboard object for widget. More...
Glib::RefPtr< Gdk::Clipboard > | get_primary_clipboard ()
| Gets the primary clipboard of widget. More...
Glib::RefPtr< const Gdk::Clipboard > | get_primary_clipboard () const
| Gets the primary clipboard of widget. More...
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space. More...
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space. More...
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget. More...
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag will be used. More...
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space. More...
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space. More...
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget. More...
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag will be used. More...
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible. More...
void | set_expand (bool expand=true)
| Sets whether the widget would like any available extra space in both directions. More...
Align | get_halign () const
| Gets the horizontal alignment of widget. More...
void | set_halign (Align align)
| Sets the horizontal alignment of widget. More...
Align | get_valign () const
| Gets the vertical alignment of widget. More...
void | set_valign (Align align)
| Sets the vertical alignment of widget. More...
int | get_margin_start () const
| Gets the start margin of widget. More...
void | set_margin_start (int margin)
| Sets the start margin of widget. More...
int | get_margin_end () const
| Gets the end margin of widget. More...
void | set_margin_end (int margin)
| Sets the end margin of widget. More...
int | get_margin_top () const
| Gets the top margin of widget. More...
void | set_margin_top (int margin)
| Sets the top margin of widget. More...
int | get_margin_bottom () const
| Gets the bottom margin of widget. More...
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget. More...
void | set_margin (int margin)
| Set all 4 margins to the same value. More...
bool | is_ancestor (Widget & ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers. More...
bool | translate_coordinates (Widget & dest_widget, double src_x, double src_y, double & dest_x, double & dest_y)
| Translate coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations. More...
bool | contains (double x, double y) const
| Tests if the point at ( x, y) is contained in widget. More...
Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT)
| Finds the descendant of widget closest to the point ( x, y). More...
const Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT) const
| Finds the descendant of widget closest to the point ( x, y). More...
void | add_controller (const Glib::RefPtr< EventController > & controller)
| Adds controller to widget so that it will receive events. More...
void | remove_controller (const Glib::RefPtr< EventController > & controller)
| Removes controller from widget, so that it doesn't process events anymore. More...
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new `Pango::Context` with the appropriate font map, font options, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a `Pango::Context` with the appropriate font map, font description, and base direction for this widget. More...
void | set_font_options (const Cairo::FontOptions & options)
| Sets the `cairo_font_options_t` used for Pango rendering in this widget. More...
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options(). More...
Cairo::FontOptions | get_font_options () const
| Returns the `cairo_font_options_t` of widget. More...
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring & text)
| Creates a new `Pango::Layout` with the appropriate font map, font description, and base direction for drawing text for this widget. More...
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget. More...
TextDirection | get_direction () const
| Gets the reading direction for a particular widget. More...
void | set_cursor (const Glib::RefPtr< Gdk::Cursor > & cursor)
| Sets the cursor to be shown when pointer devices point towards widget. More...
void | set_cursor (const Glib::ustring & name={})
| Sets a named cursor to be shown when pointer devices point towards the widget. More...
Glib::RefPtr< Gdk::Cursor > | get_cursor ()
| Queries the cursor set on widget. More...
Glib::RefPtr< const Gdk::Cursor > | get_cursor () const
| Queries the cursor set on widget. More...
std::vector< Widget * > | list_mnemonic_labels ()
| Returns the widgets for which this widget is the target of a mnemonic. More...
std::vector< const Widget * > | list_mnemonic_labels () const
| Returns the widgets for which this widget is the target of a mnemonic. More...
void | add_mnemonic_label (Widget & label)
| Adds a widget to the list of mnemonic labels for this widget. More...
void | remove_mnemonic_label (Widget & label)
| Removes a widget from the list of mnemonic labels for this widget. More...
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a drag movement has passed the GTK drag threshold. More...
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget. More...
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget. More...
void | set_parent (Widget & parent)
| Sets parent as the parent widget of widget. More...
void | unparent ()
| Dissociate widget from its parent. More...
void | map ()
| Causes a widget to be mapped if it isn’t already. More...
void | unmap ()
| Causes a widget to be unmapped if it’s currently mapped. More...
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located. More...
void | set_tooltip_text (const Glib::ustring & text)
| Sets text as the contents of the tooltip. More...
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget. More...
void | set_tooltip_markup (const Glib::ustring & markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language. More...
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget. More...
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the `has-tooltip` property on widget to has_tooltip. More...
bool | get_has_tooltip () const
| Returns the current value of the `has-tooltip` property. More...
bool | in_destruction () const
| Returns whether the widget is currently being destroyed. More...
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget. More...
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the style context associated to widget. More...
guint | add_tick_callback (const SlotTick & slot)
| Queues an animation frame update and adds a callback to be called before each frame. More...
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback(). More...
void | insert_action_group (const Glib::ustring & name, const Glib::RefPtr< Gio::ActionGroup > & group)
| Inserts group into widget. More...
void | remove_action_group (const Glib::ustring & name)
| Removes a group from the widget. More...
bool | activate_action (const Glib::ustring & name, const Glib::VariantBase & args={})
| Looks up the action in the action groups associated with the widget and its ancestors, and activates it. More...
void | activate_default ()
| Activates the `default.activate` action from widget. More...
void | set_font_map (const Glib::RefPtr< Pango::FontMap > & font_map)
| Sets the font map to use for Pango rendering. More...
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map of widget. More...
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map of widget. More...
Widget * | get_first_child ()
| Returns the widgets first child. More...
const Widget * | get_first_child () const
| Returns the widgets first child. More...
Widget * | get_last_child ()
| Returns the widgets last child. More...
const Widget * | get_last_child () const
| Returns the widgets last child. More...
Widget * | get_next_sibling ()
| Returns the widgets next sibling. More...
const Widget * | get_next_sibling () const
| Returns the widgets next sibling. More...
Widget * | get_prev_sibling ()
| Returns the widgets previous sibling. More...
const Widget * | get_prev_sibling () const
| Returns the widgets previous sibling. More...
Glib::RefPtr< Gio::ListModel > | observe_children ()
| Returns a `Gio::ListModel` to track the children of widget. More...
Glib::RefPtr< const Gio::ListModel > | observe_children () const
| Returns a `Gio::ListModel` to track the children of widget. More...
Glib::RefPtr< Gio::ListModel > | observe_controllers ()
| Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget. More...
Glib::RefPtr< const Gio::ListModel > | observe_controllers () const
| Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget. More...
void | insert_after (Widget & parent, const Widget & previous_sibling)
| Inserts the Widget into the child widget list of parent after previous_sibling. More...
void | insert_before (Widget & parent, const Widget & next_sibling)
| Inserts the Widget into the child widget list of parent before next_sibling. More...
void | insert_at_start (Widget & parent)
| Inserts the Widget at the beginning of the child widget list of parent. More...
void | insert_at_end (Widget & parent)
| Inserts the Widget at the end of the child widget list of parent. More...
void | snapshot_child (Widget & child, const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Snapshot the a child of widget. More...
bool | should_layout () const
| Returns whether widget should contribute to the measuring and allocation of its parent. More...
Glib::ustring | get_css_name () const
| Returns the CSS name that is used for self. More...
void | add_css_class (const Glib::ustring & css_class)
| Adds a style class to widget. More...
void | remove_css_class (const Glib::ustring & css_class)
| Removes a style from widget. More...
bool | has_css_class (const Glib::ustring & css_class) const
| Returns whether css_class is currently applied to widget. More...
std::vector< Glib::ustring > | get_css_classes () const
| Returns the list of style classes applied to widget. More...
void | set_css_classes (const std::vector< Glib::ustring > & classes)
| Clear all style classes applied to widget and replace them with classes. More...
Gdk::RGBA | get_color () const
| Gets the current foreground color for the widget's CSS style. More...
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen. More...
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget. More...
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< void()> | signal_destroy ()
| Emitted during the dispose phase. More...
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip > &)> | signal_query_tooltip ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget. More...
Glib::PropertyProxy_ReadOnly< Widget * > | property_parent () const
| The parent widget of this widget. More...
Glib::PropertyProxy_ReadOnly< Root * > | property_root () const
| The `Gtk::Root` widget of the widget tree containing this widget. More...
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget. More...
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget. More...
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible. More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible. More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input. More...
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input. More...
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget or any of its descendents can accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget or any of its descendents can accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus. More...
Glib::PropertyProxy< bool > | property_can_target ()
| Whether the widget can receive pointer events. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_target () const
| Whether the widget can receive pointer events. More...
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse. More...
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse. More...
Glib::PropertyProxy< bool > | property_focusable ()
| Whether this widget itself will accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_focusable () const
| Whether this widget itself will accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget. More...
Glib::PropertyProxy< bool > | property_receives_default ()
| Whether the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| Whether the widget will receive the default action when it is focused. More...
Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > | property_cursor ()
| The cursor used by widget. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > | property_cursor () const
| The cursor used by widget. More...
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of the signal_query_tooltip() signal on widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of the signal_query_tooltip() signal on widget. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with Pango markup. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with Pango markup. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string. More...
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space. More...
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space. More...
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space. More...
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space. More...
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally. More...
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally. More...
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget. More...
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget. More...
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally. More...
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally. More...
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the `hexpand` property. More...
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the `hexpand` property. More...
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically. More...
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically. More...
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the `vexpand` property. More...
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the `vexpand` property. More...
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget. More...
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget. More...
Glib::PropertyProxy< Overflow > | property_overflow ()
| How content outside the widget's content area is treated. More...
Glib::PropertyProxy_ReadOnly< Overflow > | property_overflow () const
| How content outside the widget's content area is treated. More...
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree. More...
Glib::PropertyProxy< std::vector< Glib::ustring > > | property_css_classes ()
| A list of css classes applied to this widget. More...
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_css_classes () const
| A list of css classes applied to this widget. More...
Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > | property_layout_manager ()
| The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > | property_layout_manager () const
| The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children. More...
Public Member Functions inherited from Gtk::Object
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gtk::Accessible
| Accessible (Accessible && src) noexcept
Accessible & | operator= (Accessible && src) noexcept
| ~Accessible () noexcept override
GtkAccessible * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkAccessible * | gobj () const
| Provides access to the underlying C GObject. More...
Glib::RefPtr< ATContext > | get_at_context ()
| Retrieves the accessible implementation for the given `Gtk::Accessible`. More...
Glib::RefPtr< const ATContext > | get_at_context () const
| Retrieves the accessible implementation for the given `Gtk::Accessible`. More...
bool | get_platform_state (PlatformState state) const
| Query a platform state, such as focus. More...
Glib::RefPtr< Accessible > | get_accessible_parent ()
| Retrieves the accessible parent for an accessible object. More...
Glib::RefPtr< const Accessible > | get_accessible_parent () const
| Retrieves the accessible parent for an accessible object. More...
void | set_accessible_parent (const Glib::RefPtr< Accessible > & parent, const Glib::RefPtr< Accessible > & next_sibling)
| Sets the parent and sibling of an accessible object. More...
Glib::RefPtr< Accessible > | get_first_accessible_child ()
| Retrieves the first accessible child of an accessible object. More...
Glib::RefPtr< const Accessible > | get_first_accessible_child () const
| Retrieves the first accessible child of an accessible object. More...
Glib::RefPtr< Accessible > | get_next_accessible_sibling ()
| Retrieves the next accessible sibling of an accessible object. More...
Glib::RefPtr< const Accessible > | get_next_accessible_sibling () const
| Retrieves the next accessible sibling of an accessible object. More...
void | update_next_accessible_sibling (const Glib::RefPtr< Accessible > & new_sibling)
| Updates the next accessible sibling of self. More...
bool | get_bounds (int & x, int & y, int & width, int & height) const
| Queries the coordinates and dimensions of this accessible. More...
Role | get_accessible_role () const
| Retrieves the accessible role of an accessible object. More...
void | update_state (State state, const Glib::ValueBase & value)
| Updates an accessible state. More...
void | update_property (Property property, const Glib::ValueBase & value)
| Updates an accessible property. More...
void | update_relation (Relation relation, const Glib::ValueBase & value)
| Updates an accessible relation. More...
void | reset_state (State state)
| Resets the accessible state to its default value. More...
void | reset_property (Property property)
| Resets the accessible property to its default value. More...
void | reset_relation (Relation relation)
| Resets the accessible relation to its default value. More...
Glib::PropertyProxy< Role > | property_accessible_role ()
| The accessible role of the given `Gtk::Accessible` implementation. More...
Glib::PropertyProxy_ReadOnly< Role > | property_accessible_role () const
| The accessible role of the given `Gtk::Accessible` implementation. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable && src) noexcept
Buildable & | operator= (Buildable && src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject. More...
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object. More...
Public Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget (ConstraintTarget && src) noexcept
ConstraintTarget & | operator= (ConstraintTarget && src) noexcept
| ~ConstraintTarget () noexcept override
GtkConstraintTarget * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkConstraintTarget * | gobj () const
| Provides access to the underlying C GObject. More...
Public Member Functions inherited from Gtk::Orientable
| Orientable (Orientable && src) noexcept
Orientable & | operator= (Orientable && src) noexcept
| ~Orientable () noexcept override
GtkOrientable * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkOrientable * | gobj () const
| Provides access to the underlying C GObject. More...
void | set_orientation (Orientation orientation)
| Sets the orientation of the orientable. More...
Orientation | get_orientation () const
| Retrieves the orientation of the orientable. More...
Glib::PropertyProxy< Orientation > | property_orientation ()
| The orientation of the orientable. More...
Glib::PropertyProxy_ReadOnly< Orientation > | property_orientation () const
| The orientation of the orientable. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets. More...
static TextDirection | get_default_direction ()
| Obtains the current default reading direction. More...
Static Public Member Functions inherited from Gtk::Accessible
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::ConstraintTarget
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Orientable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Gtk::FlowBox * | wrap (GtkFlowBox * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Widget
Gtk::Widget * | wrap (GtkWidget * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Accessible
Glib::RefPtr< Gtk::Accessible > | wrap (GtkAccessible * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::ConstraintTarget
Glib::RefPtr< Gtk::ConstraintTarget > | wrap (GtkConstraintTarget * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Orientable
Glib::RefPtr< Gtk::Orientable > | wrap (GtkOrientable * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Protected Member Functions inherited from Gtk::Widget
virtual void | root_vfunc ()
virtual void | unroot_vfunc ()
virtual void | size_allocate_vfunc (int width, int height, int baseline)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
virtual bool | grab_focus_vfunc ()
virtual void | set_focus_child_vfunc (Widget * child)
| Sets the focused child of widget. More...
virtual void | compute_expand_vfunc (bool & hexpand_p, bool & vexpand_p)
virtual bool | contains_vfunc (double x, double y) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Widget ()
void | realize ()
| Creates the GDK resources associated with a widget. More...
void | unrealize ()
| Causes a widget to be unrealized (frees all GDK resources associated with the widget). More...
void | realize_if_needed ()
void | set_focus_child (Widget & child)
| Set child as the current focus child of widget. More...
void | unset_focus_child ()
| Unsets the focus child of the widget. More...
Widget * | get_focus_child ()
| Returns the current focus child of widget. More...
const Widget * | get_focus_child () const
| Returns the current focus child of widget. More...
virtual void | on_show ()
| This is a default handler for the signal signal_show(). More...
virtual void | on_hide ()
| This is a default handler for the signal signal_hide(). More...
virtual void | on_map ()
| This is a default handler for the signal signal_map(). More...
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap(). More...
virtual void | on_realize ()
| This is a default handler for the signal signal_realize(). More...
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize(). More...
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed(). More...
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed(). More...
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate(). More...
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip > & tooltip)
| This is a default handler for the signal signal_query_tooltip(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Accessible
| Accessible ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Gtk::Orientable
| Orientable ()
| You should derive from this class to use it. More...

## Detailed Description

A container that allows reflowing its children.

A FlowBox positions child widgets in sequence according to its orientation.

For instance, with the horizontal orientation, the widgets will be arranged from left to right, starting a new row under the previous row when necessary. Reducing the width in this case will require more rows, so a larger height will be requested.

Likewise, with the vertical orientation, the widgets will be arranged from top to bottom, starting a new column to the right when necessary. Reducing the height will require more columns, so a larger width will be requested.

The children of a FlowBox can be dynamically sorted and filtered.

Although a FlowBox must have only FlowBoxChild children, you can add any kind of widget to it via insert(), and a FlowBoxChild widget will automatically be inserted between the box and the widget.

Also see ListBox.

Since gtkmm 3.12:

## Member Typedef Documentation

## ◆ SlotCreateWidget

template <typename T_item >

using Gtk::FlowBox::SlotCreateWidget = sigc::slot<Gtk::Widget*(const Glib::RefPtr<T_item>&)>

For instance: Gtk::Widget* on_create_widget(const Glib::RefPtr<T_item>& item);.

Called for flow boxes that are bound to a Gio::ListModel with bind_model() or bind_list_store() for each item that gets added to the model.

Since gtkmm 3.22:

Template Parameters

  T_item | Base class of the items in the Gio::ListModel. All items must be of type T_item or a type derived from T_item. T_item must be Glib::Object or a type derived from Glib::Object.

Parameters

  item | The item from the model for which to create a widget.

Returns
  A Gtk::Widget that represents item.

## ◆ SlotFilter

typedef sigc::slot<bool(FlowBoxChild*)> Gtk::FlowBox::SlotFilter

For instance: bool on_filter(FlowBoxChild* child);.

Will be called for each child after a call to FlowBox::set_filter_func(), and it will continue to be called each time a child changes (via FlowBoxChild::changed()) or when FlowBox::invalidate_filter() is called.

Parameters

  child | A FlowBoxChild that may be filtered

Returns
  `true` if the child should be visible, `false` otherwise

Since gtkmm 3.12:

## ◆ SlotSelectedForeach

typedef sigc::slot<void(FlowBox*, FlowBoxChild*)> Gtk::FlowBox::SlotSelectedForeach

For instance: void foreach_child(FlowBox* box, FlowBoxChild* child);.

A function used by FlowBox::selected_foreach(). It will be called on every selected child of the box.

Parameters

  box | FlowBox containing the selected children
  child | Each selected FlowBoxChild

Since gtkmm 3.12:

## ◆ SlotSort

typedef sigc::slot<int(FlowBoxChild*, FlowBoxChild*)> Gtk::FlowBox::SlotSort

For instance: int on_sort(FlowBoxChild* child1, FlowBoxChild* child2)

Will be called for each child after a call to FlowBox::set_sort_func(), and will continue to be called each time a child changes (via FlowBoxChild::changed()) and when FlowBox::invalidate_sort() is called.

Parameters

  child1 | The first child.
  child2 | The second child.

Returns
  < 0 if child1 should be before child2, 0 if they are equal, and > 0 otherwise

Since gtkmm 3.12:

## Constructor & Destructor Documentation

## ◆ FlowBox() [1/3]

Gtk::FlowBox::FlowBox | ( | FlowBox && | src | ) |
| noexcept

## ◆ FlowBox() [2/3]

Gtk::FlowBox::FlowBox | ( | const FlowBox & |  | ) |
| delete

## ◆ ~FlowBox()

Gtk::FlowBox::~FlowBox | ( |  | ) |
| override noexcept

## ◆ FlowBox() [3/3]

Gtk::FlowBox::FlowBox | ( |  | ) |

Creates a FlowBox.

## Member Function Documentation

## ◆ append()

void Gtk::FlowBox::append | ( | Widget & | child | ) |

Adds child to the end of self.

If a sort function is set, the widget will actually be inserted at the calculated position.

See also: insert().

Since gtkmm 4.6:

Parameters

  child | The `Gtk::Widget` to add.

## ◆ bind_list_store()

template <typename T_item , typename T_slot >

void Gtk::FlowBox::bind_list_store | ( | const Glib::RefPtr< Gio::ListStore< T_item >> & | store,
|  | T_slot && | slot_create_widget
| ) |  |

Binds a Gio::ListStore<>.

If this FlowBox was already bound to a Gio::ListModel, that previous binding is destroyed. (Gio::ListStore is a Gio::ListModel.)

The contents of the FlowBox are cleared and then filled with widgets that represent items from store. The FlowBox is updated whenever store changes. If store is an empty Glib::RefPtr, the FlowBox is left empty.

It is undefined to add or remove widgets directly (for example, with insert() or Gtk::Container::add()) while the FlowBox is bound to a model.

Note that using a model is incompatible with the filtering and sorting functionality in FlowBox. When using a model, filtering and sorting should be implemented by the model.

Since gtkmm 3.22:

Template Parameters

  T_item | Base class of the items in the Gio::ListStore. All items must be of type T_item or a type derived from T_item. T_item must be Glib::Object or a type derived from Glib::Object.
  T_slot | SlotCreateWidget<T_item> or a type that can be converted to SlotCreateWidget<T_item>.

Parameters

  store | The Gio::ListStore<> to be bound.
  slot_create_widget | A slot that creates widgets for items.

## ◆ bind_model()

void Gtk::FlowBox::bind_model | ( | const Glib::RefPtr< Gio::ListModel > & | model,
|  | const SlotCreateWidget< Glib::Object > & | slot_create_widget
| ) |  |

Binds a Gio::ListModel.

If this FlowBox was already bound to a model, that previous binding is destroyed.

The contents of the FlowBox are cleared and then filled with widgets that represent items from model. The FlowBox is updated whenever model changes. If model is an empty Glib::RefPtr, the FlowBox is left empty.

It is undefined to add or remove widgets directly (for example, with insert() or Gtk::Container::add()) while the FlowBox is bound to a model.

Note that using a model is incompatible with the filtering and sorting functionality in FlowBox. When using a model, filtering and sorting should be implemented by the model.

Since gtkmm 3.22:

Parameters

  model | The Gio::ListModel to be bound.
  slot_create_widget | A slot that creates widgets for items.

See also
  bind_list_store()

## ◆ get_activate_on_single_click()

bool Gtk::FlowBox::get_activate_on_single_click | ( |  | ) | const

Returns whether children activate on single clicks.

Returns
  `true` if children are activated on single click, `false` otherwise.

## ◆ get_child_at_index() [1/2]

FlowBoxChild* Gtk::FlowBox::get_child_at_index | ( | int | idx | ) |

Gets the nth child in the box.

Parameters

  idx | The position of the child.

Returns
  The child widget, which will always be a `Gtk::FlowBoxChild` or `nullptr` in case no child widget with the given index exists.

## ◆ get_child_at_index() [2/2]

const FlowBoxChild* Gtk::FlowBox::get_child_at_index | ( | int | idx | ) | const

Gets the nth child in the box.

Parameters

  idx | The position of the child.

Returns
  The child widget, which will always be a `Gtk::FlowBoxChild` or `nullptr` in case no child widget with the given index exists.

## ◆ get_child_at_pos() [1/2]

FlowBoxChild* Gtk::FlowBox::get_child_at_pos | ( | int | x,
|  | int | y
| ) |  |

Gets the child in the ( x, y) position.

Both x and y are assumed to be relative to the origin of box.

Parameters

  x | The x coordinate of the child.
  y | The y coordinate of the child.

Returns
  The child widget, which will always be a `Gtk::FlowBoxChild` or `nullptr` in case no child widget exists for the given x and y coordinates.

## ◆ get_child_at_pos() [2/2]

const FlowBoxChild* Gtk::FlowBox::get_child_at_pos | ( | int | x,
|  | int | y
| ) |  | const

Gets the child in the ( x, y) position.

Both x and y are assumed to be relative to the origin of box.

Parameters

  x | The x coordinate of the child.
  y | The y coordinate of the child.

Returns
  The child widget, which will always be a `Gtk::FlowBoxChild` or `nullptr` in case no child widget exists for the given x and y coordinates.

## ◆ get_column_spacing()

guint Gtk::FlowBox::get_column_spacing | ( |  | ) | const

Gets the horizontal spacing.

Returns
  The horizontal spacing.

## ◆ get_homogeneous()

bool Gtk::FlowBox::get_homogeneous | ( |  | ) | const

Returns whether the box is homogeneous.

Returns
  `true` if the box is homogeneous.

## ◆ get_max_children_per_line()

guint Gtk::FlowBox::get_max_children_per_line | ( |  | ) | const

Gets the maximum number of children per line.

Returns
  The maximum number of children per line.

## ◆ get_min_children_per_line()

guint Gtk::FlowBox::get_min_children_per_line | ( |  | ) | const

Gets the minimum number of children per line.

Returns
  The minimum number of children per line.

## ◆ get_row_spacing()

guint Gtk::FlowBox::get_row_spacing | ( |  | ) | const

Gets the vertical spacing.

Returns
  The vertical spacing.

## ◆ get_selected_children() [1/2]

std::vector< Gtk::FlowBoxChild*> Gtk::FlowBox::get_selected_children | ( |  | ) |

Creates a list of all selected children.

Returns
  A `GList` containing the `Gtk::Widget` for each selected child.

## ◆ get_selected_children() [2/2]

std::vector< const Gtk::FlowBoxChild*> Gtk::FlowBox::get_selected_children | ( |  | ) | const

Creates a list of all selected children.

Returns
  A `GList` containing the `Gtk::Widget` for each selected child.

## ◆ get_selection_mode()

SelectionMode Gtk::FlowBox::get_selection_mode | ( |  | ) | const

Gets the selection mode of box.

Returns
  The `Gtk::SelectionMode`.

## ◆ get_type()

static GType Gtk::FlowBox::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkFlowBox* Gtk::FlowBox::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkFlowBox* Gtk::FlowBox::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ insert()

void Gtk::FlowBox::insert | ( | Widget & | widget,
|  | int | position
| ) |  |

Inserts the widget into box at position.

If a sort function is set, the widget will actually be inserted at the calculated position.

If position is -1, or larger than the total number of children in the box, then the widget will be appended to the end.

Parameters

  widget | The `Gtk::Widget` to add.
  position | The position to insert child in.

## ◆ invalidate_filter()

void Gtk::FlowBox::invalidate_filter | ( |  | ) |

Updates the filtering for all children.

Call this function when the result of the filter function on the box is changed due to an external factor. For instance, this would be used if the filter function just looked for a specific search term, and the entry with the string has changed.

## ◆ invalidate_sort()

void Gtk::FlowBox::invalidate_sort | ( |  | ) |

Updates the sorting for all children.

Call this when the result of the sort function on box is changed due to an external factor.

## ◆ operator=() [1/2]

FlowBox& Gtk::FlowBox::operator= | ( | const FlowBox & |  | ) |
| delete

## ◆ operator=() [2/2]

FlowBox& Gtk::FlowBox::operator= | ( | FlowBox && | src | ) |
| noexcept

## ◆ prepend()

void Gtk::FlowBox::prepend | ( | Widget & | child | ) |

Adds child to the start of self.

If a sort function is set, the widget will actually be inserted at the calculated position.

See also: insert().

Since gtkmm 4.6:

Parameters

  child | The `Gtk::Widget` to add.

## ◆ property_accept_unpaired_release() [1/2]

Glib::PropertyProxy< bool > Gtk::FlowBox::property_accept_unpaired_release | ( |  | ) |

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_accept_unpaired_release() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::FlowBox::property_accept_unpaired_release | ( |  | ) | const

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_activate_on_single_click() [1/2]

Glib::PropertyProxy< bool > Gtk::FlowBox::property_activate_on_single_click | ( |  | ) |

Determines whether children can be activated with a single click, or require a double-click.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_activate_on_single_click() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::FlowBox::property_activate_on_single_click | ( |  | ) | const

Determines whether children can be activated with a single click, or require a double-click.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_column_spacing() [1/2]

Glib::PropertyProxy< guint > Gtk::FlowBox::property_column_spacing | ( |  | ) |

The amount of horizontal space between two children.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_column_spacing() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gtk::FlowBox::property_column_spacing | ( |  | ) | const

The amount of horizontal space between two children.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_homogeneous() [1/2]

Glib::PropertyProxy< bool > Gtk::FlowBox::property_homogeneous | ( |  | ) |

Determines whether all children should be allocated the same size.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_homogeneous() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::FlowBox::property_homogeneous | ( |  | ) | const

Determines whether all children should be allocated the same size.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_max_children_per_line() [1/2]

Glib::PropertyProxy< guint > Gtk::FlowBox::property_max_children_per_line | ( |  | ) |

The maximum amount of children to request space for consecutively in the given orientation.

Default value: 7

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_max_children_per_line() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gtk::FlowBox::property_max_children_per_line | ( |  | ) | const

The maximum amount of children to request space for consecutively in the given orientation.

Default value: 7

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_min_children_per_line() [1/2]

Glib::PropertyProxy< guint > Gtk::FlowBox::property_min_children_per_line | ( |  | ) |

The minimum number of children to allocate consecutively in the given orientation.

Setting the minimum children per line ensures that a reasonably small height will be requested for the overall minimum width of the box.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_min_children_per_line() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gtk::FlowBox::property_min_children_per_line | ( |  | ) | const

The minimum number of children to allocate consecutively in the given orientation.

Setting the minimum children per line ensures that a reasonably small height will be requested for the overall minimum width of the box.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_row_spacing() [1/2]

Glib::PropertyProxy< guint > Gtk::FlowBox::property_row_spacing | ( |  | ) |

The amount of vertical space between two children.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_row_spacing() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gtk::FlowBox::property_row_spacing | ( |  | ) | const

The amount of vertical space between two children.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_selection_mode() [1/2]

Glib::PropertyProxy< SelectionMode > Gtk::FlowBox::property_selection_mode | ( |  | ) |

The selection mode used by the flow box.

Default value: Gtk::SelectionMode::SINGLE

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_selection_mode() [2/2]

Glib::PropertyProxy_ReadOnly< SelectionMode > Gtk::FlowBox::property_selection_mode | ( |  | ) | const

The selection mode used by the flow box.

Default value: Gtk::SelectionMode::SINGLE

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ remove()

void Gtk::FlowBox::remove | ( | Widget & | widget | ) |

Removes a child from box.

Parameters

  widget | The child widget to remove.

## ◆ select_all()

void Gtk::FlowBox::select_all | ( |  | ) |

Select all children of box, if the selection mode allows it.

## ◆ select_child()

void Gtk::FlowBox::select_child | ( | FlowBoxChild & | child | ) |

Selects a single child of box, if the selection mode allows it.

Parameters

  child | A child of box.

## ◆ selected_foreach()

void Gtk::FlowBox::selected_foreach | ( | const SlotSelectedForeach & | slot | ) |

Calls a function for each selected child.

Note that the selection cannot be modified from within this function.

Parameters

  slot | The function to call for each selected child

Since gtkmm 3.12:

## ◆ set_activate_on_single_click()

void Gtk::FlowBox::set_activate_on_single_click | ( | bool | single = `true` | ) |

If single is `true`, children will be activated when you click on them, otherwise you need to double-click.

Parameters

  single | `true` to emit child-activated on a single click.

## ◆ set_column_spacing()

void Gtk::FlowBox::set_column_spacing | ( | guint | spacing | ) |

Sets the horizontal space to add between children.

Parameters

  spacing | The spacing to use.

## ◆ set_filter_func()

void Gtk::FlowBox::set_filter_func | ( | const SlotFilter & | slot | ) |

Sets a filter function.

By setting a filter function on the FlowBox one can decide dynamically which of the children to show. For instance, to implement a search function that only shows the children matching the search terms.

The slot will be called for each child after the call, and it will continue to be called each time a child changes (via FlowBoxChild::changed()) or when FlowBox::invalidate_filter() is called.

Parameters

  slot | Callback that lets you filter which children to show

Since gtkmm 3.12:

## ◆ set_hadjustment()

void Gtk::FlowBox::set_hadjustment | ( | const Glib::RefPtr< Adjustment > & | adjustment | ) |

Hooks up an adjustment to focus handling in box.

The adjustment is also used for autoscrolling during rubberband selection. See Gtk::ScrolledWindow::get_hadjustment() for a typical way of obtaining the adjustment, and set_vadjustment() for setting the vertical adjustment.

The adjustments have to be in pixel units and in the same coordinate system as the allocation for immediate children of the box.

Parameters

  adjustment | An adjustment which should be adjusted when the focus is moved among the descendents of container.

## ◆ set_homogeneous()

void Gtk::FlowBox::set_homogeneous | ( | bool | homogeneous = `true` | ) |

Sets whether or not all children of box are given equal space in the box.

Parameters

  homogeneous | `true` to create equal allotments, `false` for variable allotments.

## ◆ set_max_children_per_line()

void Gtk::FlowBox::set_max_children_per_line | ( | guint | n_children | ) |

Sets the maximum number of children to request and allocate space for in box’s orientation.

Setting the maximum number of children per line limits the overall natural size request to be no more than n_children children long in the given orientation.

Parameters

  n_children | The maximum number of children per line.

## ◆ set_min_children_per_line()

void Gtk::FlowBox::set_min_children_per_line | ( | guint | n_children | ) |

Sets the minimum number of children to line up in box’s orientation before flowing.

Parameters

  n_children | The minimum number of children per line.

## ◆ set_row_spacing()

void Gtk::FlowBox::set_row_spacing | ( | guint | spacing | ) |

Sets the vertical space to add between children.

Parameters

  spacing | The spacing to use.

## ◆ set_selection_mode()

void Gtk::FlowBox::set_selection_mode | ( | SelectionMode | mode = `SelectionMode::NONE` | ) |

Sets how selection works in box.

Parameters

  mode | The new selection mode.

## ◆ set_sort_func()

void Gtk::FlowBox::set_sort_func | ( | const SlotSort & | slot | ) |

Sets a sort function.

By setting a sort function on the FlowBox, one can dynamically reorder the children of the box, based on the contents of the children.

The slot will be called for each child after the call, and will continue to be called each time a child changes (via FlowBoxChild::changed()) and when FlowBox::invalidate_sort() is called.

Parameters

  slot | The sort function

Since gtkmm 3.12:

## ◆ set_vadjustment()

void Gtk::FlowBox::set_vadjustment | ( | const Glib::RefPtr< Adjustment > & | adjustment | ) |

Hooks up an adjustment to focus handling in box.

The adjustment is also used for autoscrolling during rubberband selection. See Gtk::ScrolledWindow::get_vadjustment() for a typical way of obtaining the adjustment, and set_hadjustment() for setting the horizontal adjustment.

The adjustments have to be in pixel units and in the same coordinate system as the allocation for immediate children of the box.

Parameters

  adjustment | An adjustment which should be adjusted when the focus is moved among the descendents of container.

## ◆ signal_child_activated()

Glib::SignalProxy<void(FlowBoxChild*)> Gtk::FlowBox::signal_child_activated | ( |  | ) |

Slot Prototype:
  `void on_my_child_activated(FlowBoxChild* child)`

Flags: Run Last

Emitted when a child has been activated by the user.

Parameters

  child | The child that is activated.

## ◆ signal_selected_children_changed()

Glib::SignalProxy<void()> Gtk::FlowBox::signal_selected_children_changed | ( |  | ) |

Slot Prototype:
  `void on_my_selected_children_changed()`

Flags: Run First

Emitted when the set of selected children changes.

Use Gtk::FlowBox::selected_foreach() or Gtk::FlowBox::get_selected_children() to obtain the selected children.

## ◆ unselect_all()

void Gtk::FlowBox::unselect_all | ( |  | ) |

Unselect all children of box, if the selection mode allows it.

## ◆ unselect_child()

void Gtk::FlowBox::unselect_child | ( | FlowBoxChild & | child | ) |

Unselects a single child of box, if the selection mode allows it.

Parameters

  child | A child of box.

## ◆ unset_filter_func()

void Gtk::FlowBox::unset_filter_func | ( |  | ) |

Removes the filter function, if any.

Since gtkmm 3.12:

## ◆ unset_sort_func()

void Gtk::FlowBox::unset_sort_func | ( |  | ) |

Removes the sort function, if any.

Since gtkmm 3.12:

## Friends And Related Function Documentation

## ◆ wrap()

Gtk::FlowBox * wrap | ( | GtkFlowBox * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.